# VLSI SAPD Documentation

Presentation | AGDS | CIF | DTR | OPENCHAMS | SPICE | Links & Contact

Public Member Functions | Static Public Member Functions
Circuit Class Reference

## Public Member Functions

void | addSimulModel (unsigned, SimulModel::Base, SimulModel::Version, std::string)
| adds a SimulModel to the circuit. More...
void | addSubCircuitPath (std::string)
| adds a path to circuit's subcircuit paths list. More...
Layout * | createLayout ()
| creates a new empty layout and associates it to the circuit. More...
Netlist * | createNetlist ()
| creates a new empty netlist and associates it to the circuit. More...
Schematic * | createSchematic ()
| creates a new empty schematic and associates it to the circuit. More...
Layout * | getLayout ()
| returns the Layout object associated to the circuit or NULL if it does not exist.
const std::string & | getName ()
| returns the name of the circuit.
Netlist * | getNetlist ()
| returns the Netlist object associated to the circuit or NULL if it does not exist.
Parameters | getParameters ()
| returns all circuit's parameters.
Schematic * | getSchematic ()
| returns the Schematic object associated to the circuit or NULL if it does not exist.
Sizing * | getSizing ()
| returns the Sizing object associated to the circuit or NULL if it does not exist.
const std::string & | getTechno ()
| returns the technology.
const std::string & | getValue (const std::string &)
| returns the value of the circuit's parameter named `name`. More...
void | setLayout (Layout *)
| sets the circuit's layout. More...
void | setSizing (Sizing *)
| sets the circuit's sizing. More...
bool | writeToFile (std::string filePath)
| writes the database to file. More...

## Static Public Member Functions

static Circuit * | readFromFile (const std::string filePath)
| creates and returns a Circuit object based on a database source file. More...

## Detailed Description

This class is the root class whihch means that having this object in hand allows to get/set any information contained in the OpenChams file parsed/drived.

## Member Function Documentation

## ◆ addSimulModel()

void addSimulModel | ( | unsigned | id,
|  | SimulModel::Base | base,
|  | SimulModel::Version | version,
|  | std::string | filePath
| ) |  |

adds a SimulModel to the circuit.

Parameters

  id | the simulation model id.
  base | the simulation model base.
  version | the simulation model version.
  filePath | the path to the netlist used by simulation model.

## ◆ addSubCircuitPath()

void addSubCircuitPath | ( | std::string | path | ) |

inline

adds a path to circuit's subcircuit paths list.

SubCircuitPaths are used to define where to search the xml file describing subcircuits used in current circuit.

## ◆ createLayout()

Layout * createLayout | ( |  | ) |

creates a new empty layout and associates it to the circuit.

Returns
  the newly created layout.

## ◆ createNetlist()

Netlist * createNetlist | ( |  | ) |

creates a new empty netlist and associates it to the circuit.

Returns
  the newly created netlist.

## ◆ createSchematic()

Schematic * createSchematic | ( |  | ) |

creates a new empty schematic and associates it to the circuit.

Returns
  the newly created schematic.

## ◆ getValue()

const std::string & getValue | ( | const std::string & | name | ) |

inline

returns the value of the circuit's parameter named `name`.

Parameters

  name | the name of the parameter.

## ◆ readFromFile()

Circuit * readFromFile | ( | const std::string | filePath | ) |

static

creates and returns a Circuit object based on a database source file.

Parameters

  filePath | the source file name.

Returns
  the newly created Circuit.

## ◆ setLayout()

void setLayout | ( | Layout * | layout | ) |

inline

sets the circuit's layout.

Parameters

  layout | the layout of the circuit.

## ◆ setSizing()

void setSizing | ( | Sizing * | sizing | ) |

inline

sets the circuit's sizing.

Parameters

  sizing | the sizing of the circuit.

## ◆ writeToFile()

bool writeToFile | ( | std::string | filePath | ) |

writes the database to file.

Parameters

  filePath | the destination file.